package net.pricefx.logic.core.metadata;

import net.pricefx.logic.core.config.Partition;

import java.util.HashMap;
import java.util.Map;

public class MetadataProvider {
    protected static MetadataProvider instance = null;

    protected Map<Partition, MetadataCache> partitionMetadata;

    public MetadataProvider() {
        partitionMetadata = new HashMap<>();
    }

    public static MetadataProvider getInstance() {
        if (instance == null) {
            instance = new MetadataProvider();
        }
        return instance;
    }

    public MetadataCache getMetadataInstance(Partition partition) {
        if (partition == null) {
            return null;
        }

        return partitionMetadata.computeIfAbsent(partition, k -> new MetadataCache(partition));
    }
}
